"use strict";
Object.defineProperty(exports, "__esModule", {
  value: true
});
function _export(target, all) {
  for (var name in all)
    Object.defineProperty(target, name, {
      enumerable: true,
      get: all[name]
    });
}
_export(exports, {
  getBabelConfig: () => getBabelConfig,
  getBabelChain: () => getBabelChain,
  applyUserBabelConfig: () => _utils.applyUserBabelConfig
});
const _export_star = require("@swc/helpers/_/_export_star");
const _babelpresetbase = _export_star._(require("@modern-js/babel-preset-base"), exports);
const _plugins = require("./plugins");
_export_star._(require("./types"), exports);
const _utils = require("@modern-js/utils");
const getBabelConfig = (libPresetOption, syntaxOption) => getBabelChain(libPresetOption, syntaxOption).toJSON();
const getBabelChain = (libPresetOption, syntaxOption) => {
  const { appDirectory, jsxTransformRuntime, enableReactPreset, enableTypescriptPreset, lodashOptions, styledComponentsOptions } = libPresetOption;
  const { syntax, type } = syntaxOption;
  const chain = (0, _babelpresetbase.createBabelChain)();
  const baseChain = (0, _babelpresetbase.getBaseBabelChain)({
    appDirectory,
    type,
    syntax,
    presets: {
      envOptions: true,
      reactOptions: enableReactPreset,
      typescriptOptions: enableTypescriptPreset ? {
        allowDeclareFields: true,
        allExtensions: true
      } : false
    },
    plugins: {
      transformRuntime: {
        corejs: false,
        // for es5 code need helper functions
        helpers: syntaxOption.syntax === "es5"
      },
      lodashOptions,
      styledComponentsOptions
    },
    jsxTransformRuntime
  });
  const plugins = (0, _plugins.getPlugins)(libPresetOption);
  return chain.merge(baseChain).merge(plugins);
};
